﻿Imports System.Data.SqlClient

Public Class _Default
    Inherits Page
    Private descriptionValue As String = Nothing

    Dim service As New localhost.WebService1


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'If Not Me.IsPostBack Then
        '    Me.BindAppointments()
        'End If
       
        Schedule1.AppointmentSettings.DataSource = cargardatos()
        Schedule1.CategorizeSettings.DataSource = categorizeItem()
    End Sub

    Private Function categorizeItem() As DataTable
        Dim dt As New DataTable

        dt.Columns.Add("Id", Type.GetType("System.Int32"))
        dt.Columns.Add("Color", Type.GetType("System.String"))
        dt.Columns.Add("FontColor", Type.GetType("System.String"))
        dt.Columns.Add("Text", Type.GetType("System.String"))

        Dim dr As DataRow
        dr = dt.NewRow()
        dr("Id") = 1
        dr("Color") = "#e04343"
        dr("FontColor") = "White"
        dr("Text") = "Red Category"
        dt.Rows.Add(dr)
        Return dt

    End Function


    Private Function cargardatos() As DataTable
        Dim dt As New DataTable

        dt.Columns.Add("Id", Type.GetType("System.Int32"))
        dt.Columns.Add("Subject", Type.GetType("System.String"))
        dt.Columns.Add("Description", Type.GetType("System.String"))
        dt.Columns.Add("AllDay", Type.GetType("System.Boolean"))
        dt.Columns.Add("StartTime", Type.GetType("System.String"))
        dt.Columns.Add("EndTime", Type.GetType("System.String"))
        dt.Columns.Add("Categorize", Type.GetType("System.String"))

        Dim dr As DataRow
        dr = dt.NewRow()
        dr("Id") = 1
        dr("Subject") = "Prueba"
        dr("Description") = "esto es una prueba"
        dr("AllDay") = False
        dr("StartTime") = "06/18/2015 15:30:00"
        dr("EndTime") = "06/18/2015 16:30:00"
        dr("Categorize") = "1"
        dt.Rows.Add(dr)
        Return dt

    End Function

    Private Sub BindAppointments()
        Dim loc As New localhost.WebService1
        Dim appointmentsData As DataTable
        appointmentsData = loc.BindAppointments()   ' Here we are calling the BindAppointments webservice method to read the data
        Schedule1.AppointmentSettings.DataSource = appointmentsData   'Here you need to pass the appointment value
    End Sub

    Private m_Arguments As Dictionary(Of String, Object)
    Public Property Arguments() As Dictionary(Of String, Object)
        Get
            Return m_Arguments
        End Get
        Set(value As Dictionary(Of String, Object))
            m_Arguments = value
        End Set
    End Property
    Protected Sub Schedule1_ServerAppointmentSaved(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments("appointment"), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        descriptionValue = If(list.ContainsKey("Description") = False, "", list("Description").ToString())
        Dim service As New localhost.WebService1
        service.Insert(list("Id").ToString(), list("Subject").ToString(), descriptionValue.ToString(), Convert.ToDateTime(list("StartTime")).ToUniversalTime().ToString(), Convert.ToDateTime(list("EndTime")).ToUniversalTime().ToString(), Convert.ToBoolean(list("AllDay")))
        Me.BindAppointments()
    End Sub

    Protected Sub Schedule1_ServerAppointmentEdited(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments("appointment"), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        descriptionValue = If(list.ContainsKey("Description") = False, "", list("Description").ToString())
        service.Update(list("Id").ToString(), list("Subject").ToString(), descriptionValue.ToString(), Convert.ToDateTime(list("StartTime")).ToUniversalTime().ToString(), Convert.ToDateTime(list("EndTime")).ToUniversalTime().ToString(), Convert.ToBoolean(list("AllDay")))
        Me.BindAppointments()
    End Sub

    Protected Sub Schedule1_ServerAppointmentDeleted(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments("appointment")(0), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        service.Delete(list("Id").ToString())
        Me.BindAppointments()
    End Sub

    Protected Sub Schedule1_ServerResizeStop(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments("appointment"), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        descriptionValue = If(list.ContainsKey("Description") = False, "", list("Description").ToString())
        service.Update(list("Id").ToString(), list("Subject").ToString(), descriptionValue.ToString(), Convert.ToDateTime(list("StartTime")).ToUniversalTime().ToString(), Convert.ToDateTime(list("EndTime")).ToUniversalTime().ToString(), Convert.ToBoolean(list("AllDay")))
        Me.BindAppointments()
    End Sub

    Protected Sub Schedule1_ServerDragStop(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments("appointment"), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        descriptionValue = If(list.ContainsKey("Description") = False, "", list("Description").ToString())
        service.Update(list("Id").ToString(), list("Subject").ToString(), descriptionValue.ToString(), Convert.ToDateTime(list("StartTime")).ToUniversalTime().ToString(), Convert.ToDateTime(list("EndTime")).ToUniversalTime().ToString(), Convert.ToBoolean(list("AllDay")))
        Me.BindAppointments()
    End Sub

    Protected Sub Schedule1_ServerAppointmentClick(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        '  Try
        Arguments = TryCast(e.Arguments("appointment"), Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        Dim Descripcion As String = If(list.ContainsKey("Descripcion_Reservacion") = False, "", list("Descripcion_Reservacion").ToString())
        'ObtenerListaInvitados(Session("Login").ToString, Session("Password").ToString, HttpUtility.HtmlDecode(dgvAreasComunes.SelectedRow.Cells(1).Text), HttpUtility.HtmlDecode(dgvAreasComunes.SelectedRow.Cells(2).Text), list("ID").ToString())
        'If Not DSInvitados Is Nothing Then
        '    If DSInvitados.Tables(0).Rows.Count > 0 Then
        '        dgvInvitadosReservacion.DataSource = DSInvitados.Tables(0)
        '        dgvInvitadosReservacion.DataBind()
        '        For x As Integer = 0 To dgvInvitadosReservacion.Rows.Count - 1
        '            Dim ddlTipoRevision As DropDownList = dgvInvitadosReservacion.Rows(x).Cells.Item(4).FindControl("ddlTipoRevision")
        '            ddlTipoRevision.SelectedValue = DSInvitados.Tables(0).Rows(x).Item(10).ToString
        '            ddlTipoRevision.Enabled = False
        '        Next
        '    Else
        '        ListaInvitadosVacia()
        '    End If
        'Else
        '    ListaInvitadosVacia()
        'End If
        'PanelInvitados.Visible = True
        'PanelDayPilot.Height = 400
        Schedule1.Height = "390px"
        '    lblDescripcionEvento.Text = Descripcion
        '    lblIdReservacion.Text = list("ID").ToString()
        'Catch ex As Exception
        '    MostrarMensaje("Error al mostrar lista de Invitados")
        ' End Try
    End Sub

    Protected Sub Schedule1_ServerMenuItemClick(sender As Object, e As Syncfusion.JavaScript.Web.ScheduleEventArgs)
        Arguments = TryCast(e.Arguments, Dictionary(Of String, Object))
        Dim list = TryCast(Arguments, Dictionary(Of String, Object))
        Dim appointment = list("targetInfo")      'Here you can get the appointment details
        Dim selectedValue = list("events")        'Here you can get the events details like which item is clicked and its text value
        If String.Equals(selectedValue("ID").ToString(), "serverappointmentclicked") Then   ' Similarly you can check the condition for other menu items click (ex: delete appointment)
            ' you can write your code here to meet your requirement
            Dim val = selectedValue("ID").ToString()        ' Here just stored the clicked menu item Id in the variable
        End If

    End Sub
End Class